Summary: Generic SPARC linux kernel
Name: kernel-sparc
Version: 2.0.35
Release: 1
%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
%define	kversion %{PACKAGE_VERSION}
Copyright: GPL
Group: Base/Kernel
ExclusiveArch: sparc
ExclusiveOS: Linux
Source: vger.rutgers.edu:/pub/linux/Sparc/kernel/v2.0/980712/sparclinux-2.0-980719.tar.gz
Source1: kernel-config.sparc
Source2: module-info
Source3: rhkmvtag.c
Patch1: kernel-smp.patch
Patch2: linux-2.0.33-freemem.patch
# patches 0 & 3-5 applied and deleted
Patch6: kernel-egcs.patch
BuildRoot: /var/tmp/kernel-root
Provides: module-info
Autoreqprov: no

%package smp
Summary: SPARC linux kernel for multiprocessor machines
Group: Base/Kernel

%description smp
This package contains the Linux kernel that is used to boot and run
your system. It includes support for machines with multiple processors,
which will signicicantly improve performance on multiprocessor machines.
It will reduce performance on a single processor machine however. Most 
hardware is instead supported by modules loaded after booting.

%package -n kernel-source
Summary: Kernel source tree
Group: Base/Kernel
Requires: kernel-headers = %{kversion}

%package -n kernel-headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel
Provides: kernel-headers

%description -n kernel-headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%description -n kernel-source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%prep
rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/src/
cd $RPM_BUILD_ROOT/usr/src
zcat $RPM_SOURCE_DIR/sparclinux-2.0-980719.tar.gz | tar -xf-
chown root.root -R linux

find linux -name "*.orig" -print | xargs rm -f
mv linux linux-%{kversion}
ln -sf linux-%{kversion} linux

cd linux-%{kversion}

%ifarch sparc
cp $RPM_SOURCE_DIR/kernel-config.sparc arch/sparc/defconfig
%endif

%patch2 -p1 
# patches 0 & 3-5 applied and deleted
%patch6 -p1 -b .egcs

# Bring in the Red Hat Kernel Module Version Tag program
cp $RPM_SOURCE_DIR/rhkmvtag.c .

# this is a bit silly, but we happen to have a dual processor sparc
# build machine so what the heck
if [ -f /proc/cpuinfo ]; then
    num=`awk -F: '/ncpus probed/ { print ($2 * 2) + 1; }' /proc/cpuinfo`
    mv Makefile Makefile.onecpu
    sed "s/^MAKE.*=make$/MAKE=make -j $num/" < Makefile.onecpu > Makefile
fi

%build
cd $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make oldconfig
make symlinks
make include/linux/version.h

%ifarch sparc
#### This is probably unnecessary ...
###rm -f /usr/include/linux 
###ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/linux /usr/include/linux
###rm -f /usr/include/asm
###ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/asm /usr/include/asm

make vmlinux
make modules

cc -o rhkmvtag rhkmvtag.c init/version.o

#### ... as is this.
###rm -f /usr/include/linux 
###ln -sf ../src/linux/include/linux /usr/include/linux
###rm -f /usr/include/asm
###ln -sf ../src/linux/include/asm /usr/include/asm
%endif

%install

rm -rf $RPM_BUILD_ROOT/usr/include
mkdir -p $RPM_BUILD_ROOT/usr/include
ln -s ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
ln -s ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -s ../src/linux/include/scsi $RPM_BUILD_ROOT/usr/include/scsi

cd $RPM_BUILD_ROOT/usr/src/linux-%{version}

rm -rf $RPM_BUILD_ROOT/boot
mkdir -p $RPM_BUILD_ROOT/boot
install -m 644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-%{KVERREL}

strip vmlinux
gzip -9nf vmlinux
cp vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinuz-%{KVERREL}
install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-%{KVERREL}
ln -sf vmlinuz-%{KVERREL} $RPM_BUILD_ROOT/boot/vmlinuz

rm -rf $RPM_BUILD_ROOT/lib/modules
mkdir -p $RPM_BUILD_ROOT/lib/modules

# move the modules to where we like them
make DESTDIR=$RPM_BUILD_ROOT modules_install

# Identify the modules directory with the Red Hat Kernel Module Version Tag
./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/%{kversion}/.rhkmvtag

mv $RPM_BUILD_ROOT/lib/modules/%{kversion} \
        $RPM_BUILD_ROOT/lib/modules/%{KVERREL}

rm -f vmlinux.gz

# now build the SMP flavor ;-)
cd $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
patch -p1 < $RPM_SOURCE_DIR/kernel-smp.patch
make clean
make oldconfig

make vmlinux
make modules

install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-smp-%{kversion}

strip vmlinux
gzip -9nf vmlinux
cp vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinuz-smp-%{KVERREL}
install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-smp-%{KVERREL}
ln -sf vmlinuz-smp-%{KVERREL} $RPM_BUILD_ROOT/boot/vmlinuz-smp

# move the modules to where we like them
make DESTDIR=$RPM_BUILD_ROOT modules_install

# Identify the modules directory with the Red Hat Kernel Module Version Tag
./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/%{kversion}/.rhkmvtag

mv $RPM_BUILD_ROOT/lib/modules/%{kversion} \
        $RPM_BUILD_ROOT/lib/modules/%{KVERREL}-smp

cd $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
rm -f rhkmvtag

# keep kernel-source archive clean
make mrproper
make oldconfig
make symlinks
make include/linux/version.h

# this generates modversions info which we want to include and we may as
# well include the depends stuff as well
make depend

# make /usr/include/scsi link
mkdir -p ../../include
ln -s /usr/src/linux/include/scsi ../../include/scsi

%clean
if [ "X" != "${RPM_BUILD_ROOT}X" ]; then
    rm -rf $RPM_BUILD_ROOT
fi

%post
cd /boot
ln -sf vmlinuz-%{KVERREL} vmlinuz
ln -sf System.map-%{KVERREL} System.map
ln -sf module-info-%{KVERREL} module-info

if [ -x /sbin/silo -a -f /etc/silo.conf ]; then
        /sbin/silo > /dev/null
fi

%post -n kernel-headers
cd /usr/src
rm -f linux
ln -snf linux-%{kversion} linux

%postun -n kernel-headers
if [ -L /usr/src/linux ]; then
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
        rm -f /usr/src/linux
    fi
fi

%postun -n kernel-source
if [ -L /usr/src/linux ]; then
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
        rm -f /usr/src/linux
    fi
fi

%files
/boot/vmlinuz
/boot/vmlinuz-%{KVERREL}
/boot/module-info-%{KVERREL}
/boot/System.map-%{KVERREL}
%dir /lib/modules
%dir /lib/modules/%{KVERREL}
/lib/modules/%{KVERREL}/.rhkmvtag
/lib/modules/%{KVERREL}/block
/lib/modules/%{KVERREL}/fs
/lib/modules/%{KVERREL}/ipv4
/lib/modules/%{KVERREL}/misc
/lib/modules/%{KVERREL}/net


%files smp
/boot/vmlinuz-smp
/boot/vmlinuz-smp-%{KVERREL}
/boot/module-info-%{KVERREL}
/boot/System.map-smp-%{KVERREL}
%dir /lib/modules
%dir /lib/modules/%{KVERREL}-smp
/lib/modules/%{KVERREL}-smp/.rhkmvtag
/lib/modules/%{KVERREL}-smp/block
/lib/modules/%{KVERREL}-smp/fs
/lib/modules/%{KVERREL}-smp/ipv4
/lib/modules/%{KVERREL}-smp/misc
/lib/modules/%{KVERREL}-smp/net

%files -n kernel-source
%dir /usr/src/linux-%{kversion}
/usr/src/linux-%{kversion}/COPYING
/usr/src/linux-%{kversion}/CREDITS
/usr/src/linux-%{kversion}/Documentation
/usr/src/linux-%{kversion}/MAINTAINERS
/usr/src/linux-%{kversion}/Makefile
/usr/src/linux-%{kversion}/Makefile.egcs
/usr/src/linux-%{kversion}/README
/usr/src/linux-%{kversion}/Rules.make
/usr/src/linux-%{kversion}/arch
/usr/src/linux-%{kversion}/drivers
/usr/src/linux-%{kversion}/fs
/usr/src/linux-%{kversion}/init
/usr/src/linux-%{kversion}/ipc
/usr/src/linux-%{kversion}/kernel
/usr/src/linux-%{kversion}/lib
/usr/src/linux-%{kversion}/mm
/usr/src/linux-%{kversion}/modules
/usr/src/linux-%{kversion}/net
/usr/src/linux-%{kversion}/scripts

%files -n kernel-headers
/usr/src/linux-%{kversion}/include/asm
/usr/src/linux-%{kversion}/include/asm-generic
/usr/src/linux-%{kversion}/include/linux
/usr/src/linux-%{kversion}/include/net
/usr/src/linux-%{kversion}/include/scsi
/usr/include/asm
/usr/include/linux
/usr/include/scsi
/usr/src/linux-%{kversion}/include/asm-%{buildarch}

%changelog
* Sun Jul 19 1998 Jeff Johnson <jbj@redhat.com>
- update to 980719.

* Tue Jul 14 1998 Jeff Johnson <jbj@redhat.com>
- hardwire CC="sparc-redhat-linux-gcc".
- update to 980712.

* Thu Jul  2 1998 Jeff Johnson <jbj@redhat.com>
- Add rhkmvtag identification.
- Kernel config changes (more like i386):
	y->m: MD_LINEAR/MD_STRIPED/CHAR_DEV_ST/CHAR_DEV_SG
	n->y: IP_TRANSPARENT_PROXY/IP_ACCT/IP_FIREWALL_VERBOSE
	y->n: IP_MASQUERADE_IPAUTOFW

* Mon Jun  1 1998 David S. Miller <davem@dm.cobaltmicro.com>
- Add -mno-fpu to sparc Makefile, needed for egcs

* Fri May 22 1998 Jeff Johnson <jbj@redhat.com>
- Follow new /boot naming conventions.
- Bundle modules with kernels.

* Thu May 21 1998 Jeff Johnson <jbj@redhat.com>
- Package for 5.1.
